/* Report function used with rdme_solve. */

/* A. Hellander 2008-12-15 */
#include "mex.h"

void reportFun1(double time, const double t0, const double tend, int *count,
		int errcode, int report_level)
/* Report function passed as argument to rdme_solve. */
{
  if (!errcode) {
    double prct=(time-t0)/(tend-t0)*100.0;
    
    switch (report_level) {
    case 1:
      mexPrintf("%i%% done.\n",(int)prct);
      break;
    case 2:
      mexPrintf("%i%% done.\n",(int)prct);
      if (!count[0])
	    mexPrintf("\t#Reaction  events = %i\n", count[1]);
      else
	    mexPrintf("\t#Reaction  events = %i%.9i\n", count[0],count[1]);
      if (!count[2])
     	mexPrintf("\t#Diffusion events = %i\n", count[3]);
      else
		mexPrintf("\t#Diffusion events = %i%.9i\n", count[3],count[2]);
	  break;
    default:
      /* May be expanded in the future... */
      break;
    }
  } else {
    switch (errcode) {
    case 1:
      mexErrMsgTxt("Negative state detected.");
      break;
    default:
      mexErrMsgTxt("Unknown error code.");
      break;
    }
  }
}
